Index: /trunk/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 441)
+++ /trunk/source/Lib/TLibCommon/TComSlice.cpp	(revision 442)
@@ -1802,94 +2219,105 @@
 
   TimingInfo *timingInfo = vui->getTimingInfo();
-  timingInfo->setTimingInfoPresentFlag( true );
-  switch( frameRate )
-  {
-  case 24:
-    timingInfo->setNumUnitsInTick( 1125000 );    timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 25:
-    timingInfo->setNumUnitsInTick( 1080000 );    timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 30:
-    timingInfo->setNumUnitsInTick( 900900 );     timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 50:
-    timingInfo->setNumUnitsInTick( 540000 );     timingInfo->setTimeScale    ( 27000000 );
-    break;
-  case 60:
-    timingInfo->setNumUnitsInTick( 450450 );     timingInfo->setTimeScale    ( 27000000 );
-    break;
-  default:
-    timingInfo->setNumUnitsInTick( 1001 );       timingInfo->setTimeScale    ( 60000 );
-    break;
-  }
-
-  Bool rateCnt = ( bitRate > 0 );
-  hrd->setNalHrdParametersPresentFlag( rateCnt );
-  hrd->setVclHrdParametersPresentFlag( rateCnt );
-
-  hrd->setSubPicCpbParamsPresentFlag( ( numDU > 1 ) );
-
-  if( hrd->getSubPicCpbParamsPresentFlag() )
-  {
-    hrd->setTickDivisorMinus2( 100 - 2 );                          // 
-    hrd->setDuCpbRemovalDelayLengthMinus1( 7 );                    // 8-bit precision ( plus 1 for last DU in AU )
-    hrd->setSubPicCpbParamsInPicTimingSEIFlag( true );
-    hrd->setDpbOutputDelayDuLengthMinus1( 5 + 7 );                 // With sub-clock tick factor of 100, at least 7 bits to have the same value as AU dpb delay
+#if TIMING_INFO_NONZERO_LAYERID_SPS
+  if( getLayerId() > 0 )
+  {
+    timingInfo->setTimingInfoPresentFlag( false );
   }
   else
   {
-    hrd->setSubPicCpbParamsInPicTimingSEIFlag( false );  
-  }
-
-  hrd->setBitRateScale( 4 );                                       // in units of 2~( 6 + 4 ) = 1,024 bps
-  hrd->setCpbSizeScale( 6 );                                       // in units of 2~( 4 + 4 ) = 1,024 bit
-  hrd->setDuCpbSizeScale( 6 );                                       // in units of 2~( 4 + 4 ) = 1,024 bit
+#endif
+    timingInfo->setTimingInfoPresentFlag( true );
+    switch( frameRate )
+    {
+    case 24:
+      timingInfo->setNumUnitsInTick( 1125000 );    timingInfo->setTimeScale    ( 27000000 );
+      break;
+    case 25:
+      timingInfo->setNumUnitsInTick( 1080000 );    timingInfo->setTimeScale    ( 27000000 );
+      break;
+    case 30:
+      timingInfo->setNumUnitsInTick( 900900 );     timingInfo->setTimeScale    ( 27000000 );
+      break;
+    case 50:
+      timingInfo->setNumUnitsInTick( 540000 );     timingInfo->setTimeScale    ( 27000000 );
+      break;
+    case 60:
+      timingInfo->setNumUnitsInTick( 450450 );     timingInfo->setTimeScale    ( 27000000 );
+      break;
+    default:
+      timingInfo->setNumUnitsInTick( 1001 );       timingInfo->setTimeScale    ( 60000 );
+      break;
+    }
+
+    Bool rateCnt = ( bitRate > 0 );
+    hrd->setNalHrdParametersPresentFlag( rateCnt );
+    hrd->setVclHrdParametersPresentFlag( rateCnt );
+
+    hrd->setSubPicCpbParamsPresentFlag( ( numDU > 1 ) );
+
+    if( hrd->getSubPicCpbParamsPresentFlag() )
+    {
+      hrd->setTickDivisorMinus2( 100 - 2 );                          // 
+      hrd->setDuCpbRemovalDelayLengthMinus1( 7 );                    // 8-bit precision ( plus 1 for last DU in AU )
+      hrd->setSubPicCpbParamsInPicTimingSEIFlag( true );
+      hrd->setDpbOutputDelayDuLengthMinus1( 5 + 7 );                 // With sub-clock tick factor of 100, at least 7 bits to have the same value as AU dpb delay
+    }
+    else
+    {
+      hrd->setSubPicCpbParamsInPicTimingSEIFlag( false );  
+    }
+
+    hrd->setBitRateScale( 4 );                                       // in units of 2~( 6 + 4 ) = 1,024 bps
+    hrd->setCpbSizeScale( 6 );                                       // in units of 2~( 4 + 4 ) = 1,024 bit
+    hrd->setDuCpbSizeScale( 6 );                                       // in units of 2~( 4 + 4 ) = 1,024 bit
   
-  hrd->setInitialCpbRemovalDelayLengthMinus1(15);                  // assuming 0.5 sec, log2( 90,000 * 0.5 ) = 16-bit
-  if( randomAccess )
-  {
-    hrd->setCpbRemovalDelayLengthMinus1(5);                        // 32 = 2^5 (plus 1)
-    hrd->setDpbOutputDelayLengthMinus1 (5);                        // 32 + 3 = 2^6
-  }
-  else
-  {
-    hrd->setCpbRemovalDelayLengthMinus1(9);                        // max. 2^10
-    hrd->setDpbOutputDelayLengthMinus1 (9);                        // max. 2^10
-  }
+    hrd->setInitialCpbRemovalDelayLengthMinus1(15);                  // assuming 0.5 sec, log2( 90,000 * 0.5 ) = 16-bit
+    if( randomAccess )
+    {
+      hrd->setCpbRemovalDelayLengthMinus1(5);                        // 32 = 2^5 (plus 1)
+      hrd->setDpbOutputDelayLengthMinus1 (5);                        // 32 + 3 = 2^6
+    }
+    else
+    {
+      hrd->setCpbRemovalDelayLengthMinus1(9);                        // max. 2^10
+      hrd->setDpbOutputDelayLengthMinus1 (9);                        // max. 2^10
+    }
 
 /*
-   Note: only the case of "vps_max_temporal_layers_minus1 = 0" is supported.
+     Note: only the case of "vps_max_temporal_layers_minus1 = 0" is supported.
 */
-  Int i, j;
-  UInt birateValue, cpbSizeValue;
-  UInt ducpbSizeValue;
-  UInt duBitRateValue = 0;
-
-  for( i = 0; i < MAX_TLAYER; i ++ )
-  {
-    hrd->setFixedPicRateFlag( i, 1 );
-    hrd->setPicDurationInTcMinus1( i, 0 );
-    hrd->setLowDelayHrdFlag( i, 0 );
-    hrd->setCpbCntMinus1( i, 0 );
-
-    birateValue  = bitRate;
-    cpbSizeValue = bitRate;                                     // 1 second
-    ducpbSizeValue = bitRate/numDU;
-    duBitRateValue = bitRate;
-    for( j = 0; j < ( hrd->getCpbCntMinus1( i ) + 1 ); j ++ )
-    {
-      hrd->setBitRateValueMinus1( i, j, 0, ( birateValue  - 1 ) );
-      hrd->setCpbSizeValueMinus1( i, j, 0, ( cpbSizeValue - 1 ) );
-      hrd->setDuCpbSizeValueMinus1( i, j, 0, ( ducpbSizeValue - 1 ) );
-      hrd->setCbrFlag( i, j, 0, ( j == 0 ) );
-
-      hrd->setBitRateValueMinus1( i, j, 1, ( birateValue  - 1) );
-      hrd->setCpbSizeValueMinus1( i, j, 1, ( cpbSizeValue - 1 ) );
-      hrd->setDuCpbSizeValueMinus1( i, j, 1, ( ducpbSizeValue - 1 ) );
-      hrd->setDuBitRateValueMinus1( i, j, 1, ( duBitRateValue - 1 ) );
-      hrd->setCbrFlag( i, j, 1, ( j == 0 ) );
-    }
-  }
+    Int i, j;
+    UInt birateValue, cpbSizeValue;
+    UInt ducpbSizeValue;
+    UInt duBitRateValue = 0;
+
+    for( i = 0; i < MAX_TLAYER; i ++ )
+    {
+      hrd->setFixedPicRateFlag( i, 1 );
+      hrd->setPicDurationInTcMinus1( i, 0 );
+      hrd->setLowDelayHrdFlag( i, 0 );
+      hrd->setCpbCntMinus1( i, 0 );
+
+      birateValue  = bitRate;
+      cpbSizeValue = bitRate;                                     // 1 second
+      ducpbSizeValue = bitRate/numDU;
+      duBitRateValue = bitRate;
+      for( j = 0; j < ( hrd->getCpbCntMinus1( i ) + 1 ); j ++ )
+      {
+        hrd->setBitRateValueMinus1( i, j, 0, ( birateValue  - 1 ) );
+        hrd->setCpbSizeValueMinus1( i, j, 0, ( cpbSizeValue - 1 ) );
+        hrd->setDuCpbSizeValueMinus1( i, j, 0, ( ducpbSizeValue - 1 ) );
+        hrd->setCbrFlag( i, j, 0, ( j == 0 ) );
+
+        hrd->setBitRateValueMinus1( i, j, 1, ( birateValue  - 1) );
+        hrd->setCpbSizeValueMinus1( i, j, 1, ( cpbSizeValue - 1 ) );
+        hrd->setDuCpbSizeValueMinus1( i, j, 1, ( ducpbSizeValue - 1 ) );
+        hrd->setDuBitRateValueMinus1( i, j, 1, ( duBitRateValue - 1 ) );
+        hrd->setCbrFlag( i, j, 1, ( j == 0 ) );
+      }
+    }
+#if TIMING_INFO_NONZERO_LAYERID_SPS
+  }
+#endif
 }
 const Int TComSPS::m_winUnitX[]={1,2,2,1};
@@ -2152,7 +2580,7 @@
 TComScalingList::TComScalingList()
 {
-  m_useTransformSkip = false;
   init();
 }
+
 TComScalingList::~TComScalingList()
 {
@@ -2162,5 +2590,9 @@
 /** set default quantization matrix to array
 */
+#if IL_SL_SIGNALLING_N0371
+Void TComSlice::setDefaultScalingList( UInt layerId )
+#else
 Void TComSlice::setDefaultScalingList()
+#endif
 {
   for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
@@ -2168,5 +2600,9 @@
     for(UInt listId=0;listId<g_scalingListNum[sizeId];listId++)
     {
+#if IL_SL_SIGNALLING_N0371
+      getScalingList()->processDefaultMarix(sizeId, listId, layerId);
+#else
       getScalingList()->processDefaultMarix(sizeId, listId);
+#endif
     }
   }
@@ -2343,13 +2779,38 @@
  * \param Index of input matrix
  */
+#if IL_SL_SIGNALLING_N0371
+Void TComScalingList::processDefaultMarix(UInt sizeId, UInt listId, UInt layerId)
+#else
 Void TComScalingList::processDefaultMarix(UInt sizeId, UInt listId)
-{
+#endif
+{
+#if IL_SL_SIGNALLING_N0371
+  Int i,coefNum = min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId]);
+  UInt* scan  = (sizeId == 0) ? g_auiSigLastScan [ SCAN_DIAG ] [ 1 ] :  g_sigLastScanCG32x32; 
+  Int *src = getScalingListDefaultAddress(sizeId, listId);   
+#endif
+
   ::memcpy(getScalingListAddress(sizeId, listId),getScalingListDefaultAddress(sizeId,listId),sizeof(Int)*min(MAX_MATRIX_COEF_NUM,(Int)g_scalingListSize[sizeId]));
+
+#if IL_SL_SIGNALLING_N0371
+  for(i = 0; i < coefNum; i++) 
+  {
+    ref_scalingListCoef[layerId][sizeId][listId][i] = src[scan[i]];
+  }
+#endif
+
   setScalingListDC(sizeId,listId,SCALING_LIST_DC);
+#if IL_SL_SIGNALLING_N0371
+  ref_scalingListDC[layerId][sizeId][listId] = SCALING_LIST_DC;
+#endif
 }
 
 /** check DC value of matrix for default matrix signaling
  */
+#if IL_SL_SIGNALLING_N0371
+Void TComScalingList::checkDcOfMatrix( UInt layerId )
+#else
 Void TComScalingList::checkDcOfMatrix()
+#endif
 {
   for(UInt sizeId = 0; sizeId < SCALING_LIST_SIZE_NUM; sizeId++)
@@ -2360,5 +2821,9 @@
       if(getScalingListDC(sizeId,listId) == 0)
       {
+#if IL_SL_SIGNALLING_N0371
+        processDefaultMarix(sizeId, listId, layerId);
+#else
         processDefaultMarix(sizeId, listId);
+#endif
       }
     }
@@ -2441,4 +2906,10 @@
         m_activeVPSId = vpsId;
         m_activeSPSId = spsId;
+
+#if IL_SL_SIGNALLING_N0371
+        activeRefPPSId[ sps->getLayerId() ] = ppsId;
+        activeRefSPSId[ sps->getLayerId() ] = spsId;
+#endif
+
         return true;
       }
@@ -2554,5 +3025,16 @@
     return;
   }        
+#if POC_RESET_FLAG
+  if( this->getPocResetFlag() )
+  {
+    setBaseColPic(refLayerIdc, xGetRefPic(rcListPic, 0)); 
+  }
+  else
+  {
+    setBaseColPic(refLayerIdc, xGetRefPic(rcListPic, getPOC())); 
+  }
+#else
   setBaseColPic(refLayerIdc, xGetRefPic(rcListPic, getPOC())); 
+#endif
 }
 #endif 
@@ -2568,5 +3050,5 @@
     //set reference picture POC of each ILP reference 
     Int thePoc = ilpPic[refLayerIdc]->getPOC(); 
-    assert(thePoc >= 0); 
+    assert(thePoc >= 0);
     assert(thePoc == pcRefPicBL->getPOC());
 
